## giada 0.19.2+ds1

=== debian/changelog ===
giada (0.19.2+ds1-1) unstable; urgency=medium

  * New upstream version 0.19.2+ds1
    - Refresh patches
  * Add 'licensecheck' target
    - Generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 10 Jan 2022 09:13:23 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# see ENVIRONMENT in dpkg-buildflags(1)
export DEB_CPPFLAGS_MAINT_APPEND =
export DEB_CXXFLAGS_MAINT_APPEND =
export DEB_LDFLAGS_MAINT_APPEND =

# workaround for an FST bug
DEB_CPPFLAGS_MAINT_APPEND += -D_fstEffect=AEffect

DATE_FMT = %Y-%m-%d
ifdef SOURCE_DATE_EPOCH
    BUILD_DATE ?= $(shell date -u -d "@$(SOURCE_DATE_EPOCH)" "+$(DATE_FMT)"  2>/dev/null || date -u -r "$(SOURCE_DATE_EPOCH)" "+$(DATE_FMT)" 2>/dev/null || date -u "+$(DATE_FMT)")
else
    BUILD_DATE ?= $(shell date "+$(DATE_FMT)")
endif

JUCE_VERSION := $(shell dpkg-query --show --showformat='$${source:Version}' juce-modules-source)

DEB_CPPFLAGS_MAINT_APPEND += -DBUILD_DATE='"$(BUILD_DATE)"' -DTEST_RESOURCES_DIR='"tests/resources/"'
DEB_CXXFLAGS_MAINT_APPEND += -std=c++17 -Wno-error -Wno-error=format-security
LIBS=$(shell pkg-config --libs libjpeg libpng libcurl rtaudio)
DEB_CXXFLAGS_MAINT_APPEND += $(shell pkg-config --cflags libjpeg libpng libcurl rtaudio)

# JUCE (used by giada) uses some c++11 features requiring atomic_store_8 and
# atomic_load_8, so we need to link with libatomic on
# armel, powerpc, powerpcspe, m68k, mips, mipsel, sh4, ...
# see also:
# - https://gcc.gnu.org/wiki/Atomic
# - https://gcc.gnu.org/wiki/Atomic/GCCMM/LIbrary
# - the 'clasp' packaging
noatomicarch = $(shell dpkg-architecture -qDEB_HOST_ARCH | egrep -x "(armel|powerpc|powerpcspe|m68k|mips|mipsel|sh4|riscv64)")
# link with libatomic on architectures without built-in atomic
ifeq ($(if $(noatomicarch),atomic), atomic)
	LIBS += -latomic
endif

DEB_LDFLAGS_MAINT_APPEND += $(LIBS)

%:
	dh $@

execute_before_dh_auto_configure:
	for d in $(notdir $(patsubst %/,%,$(wildcard debian/missing-sources/mcl-*/))); do \
		mkdir -p src/deps/$$d/src/; \
		cp debian/missing-sources/$$d/* src/deps/$$d/src/; \
	done
	cp -ra /usr/share/juce src/deps/
	# patch around some bugs in FST
	sed -e 's|\(.*t_fstTimeInfo.smpteFrameRate.*\)|};\ntypedef enum {\1|' -e 's|\(.*SmpteFilm35mm.*\)|\1 } VstSmpteFrameRate;\nenum {dummy_enum|' /usr/include/pluginterfaces/fst/fst.h > src/deps/juce/modules/juce_audio_processors/format_types/fst.h
	sed -e 's|<pluginterfaces/fst/fst.h>|"fst.h"|' -i src/deps/juce/modules/juce_audio_processors/format_types/juce_VSTPluginFormat.cpp
override_dh_auto_configure:
	dh_auto_configure -- \
		-DWITH_VST2=ON \
		$(empty)

override_dh_auto_test:
	HOME=/tmp xvfb-run -a dh_auto_test -a || (grep . test-suite.log giada_test.log; false)

execute_after_dh_clean:
	test -e src/deps/rtaudio-mode/Makefile && make -C src/deps/rtaudio-mod/ distclean || true
	for d in $(notdir $(patsubst %/,%,$(wildcard debian/missing-sources/mcl-*/))); do \
		rm -rf src/deps/$$d; \
	done
	rm -rf src/deps/juce/

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_gencontrol:
	dh_gencontrol -- \
                -Vjuce:BuiltUsing="juce ( = $(JUCE_VERSION) )"


DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
	\.pc/.*|\.git/.*|debian/.*|.*\.png

licensecheck:
	licensecheck -i "^\./($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" --deb-machine -r . \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints

## giada 0.20.0%2Bds1

=== CMakeLists.txt ===
# ------------------------------------------------------------------------------
# Preliminary setup
# ------------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.12)

# CMAKE_OSX_DEPLOYMENT_TARGET should be set prior to the first project() or
# enable_language() command invocation because it may influence configuration
# of the toolchain and flags.
# Also, see https://stackoverflow.com/questions/34208360/cmake-seems-to-ignore-cmake-osx-deployment-target

if(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
	set(CMAKE_OSX_DEPLOYMENT_TARGET "10.14" CACHE STRING "Minimum OS X deployment version")
endif()

# ------------------------------------------------------------------------------
# Project
# ------------------------------------------------------------------------------

project(giada LANGUAGES CXX)

# ------------------------------------------------------------------------------
# Lists definition
#
# SOURCES - contains the source files
# PREPROCESSOR_DEFS - preprocessor definitions
# INCLUDE_DIRS - include directories (e.g. -I)
# COMPILER_OPTIONS - additional flags for the compiler
# LIBRARIES - external dependencies to link
# COMPILER_FEATURES - e.g. C++17
# TARGET_PROPERTIES - additional properties for the target 'giada'.
# ------------------------------------------------------------------------------

list(APPEND SOURCES
	src/main.cpp
	src/core/engine.cpp
	src/core/worker.cpp
	src/core/eventDispatcher.cpp
	src/core/midiDispatcher.cpp
	src/core/midiMapper.cpp
	src/core/midiEvent.cpp
	src/core/quantizer.cpp
	src/core/conf.cpp
	src/core/kernelAudio.cpp
	src/core/jackTransport.cpp
	src/core/mixerHandler.cpp
	src/core/sequencer.cpp
	src/core/metronome.cpp
	src/core/init.cpp
	src/core/wave.cpp
	src/core/waveFx.cpp
	src/core/kernelMidi.cpp
	src/core/graphics.cpp
	src/core/patch.cpp
	src/core/actions/actionRecorder.cpp
	src/core/actions/actions.cpp
	src/core/mixer.cpp
    src/core/synchronizer.cpp
	src/core/waveManager.cpp
    src/core/recorder.cpp
	src/core/midiLearnParam.cpp
	src/core/resampler.cpp
	src/core/plugins/pluginHost.cpp
	src/core/plugins/pluginManager.cpp
	src/core/plugins/plugin.cpp
	src/core/plugins/pluginState.cpp
	src/core/channels/sampleActionRecorder.cpp
	src/core/channels/midiActionRecorder.cpp
	src/core/channels/waveReader.cpp
	src/core/channels/midiController.cpp
	src/core/channels/sampleReactor.cpp
	src/core/channels/sampleAdvancer.cpp
	src/core/channels/samplePlayer.cpp
	src/core/channels/audioReceiver.cpp
	src/core/channels/midiLighter.cpp
	src/core/channels/midiLearner.cpp
	src/core/channels/midiSender.cpp
	src/core/channels/midiReceiver.cpp
	src/core/channels/channel.cpp
	src/core/channels/channelManager.cpp
	src/core/model/sequencer.cpp
	src/core/model/mixer.cpp
	src/core/model/recorder.cpp
	src/core/model/model.cpp
	src/core/model/storage.cpp
	src/core/idManager.cpp
	src/glue/events.cpp
	src/glue/main.cpp
	src/glue/io.cpp
	src/glue/storage.cpp
	src/glue/channel.cpp
	src/glue/plugin.cpp
	src/glue/recorder.cpp
	src/glue/sampleEditor.cpp
	src/glue/actionEditor.cpp
	src/glue/config.cpp
	src/glue/layout.cpp
	src/gui/ui.cpp
	src/gui/dialogs/window.cpp
	src/gui/dispatcher.cpp
	src/gui/updater.cpp
	src/gui/drawing.cpp
	src/gui/dialogs/progress.cpp
	src/gui/dialogs/keyGrabber.cpp
	src/gui/dialogs/about.cpp
	src/gui/dialogs/mainWindow.cpp
	src/gui/dialogs/beatsInput.cpp
	src/gui/dialogs/warnings.cpp
	src/gui/dialogs/bpmInput.cpp
	src/gui/dialogs/channelNameInput.cpp
	src/gui/dialogs/config.cpp
	src/gui/dialogs/pluginList.cpp
	src/gui/dialogs/pluginWindow.cpp
	src/gui/dialogs/sampleEditor.cpp
	src/gui/dialogs/pluginWindowGUI.cpp
	src/gui/dialogs/pluginChooser.cpp
	src/gui/dialogs/actionEditor/baseActionEditor.cpp
	src/gui/dialogs/actionEditor/sampleActionEditor.cpp
	src/gui/dialogs/actionEditor/midiActionEditor.cpp
	src/gui/dialogs/browser/browserBase.cpp
	src/gui/dialogs/browser/browserDir.cpp
	src/gui/dialogs/browser/browserLoad.cpp
	src/gui/dialogs/browser/browserSave.cpp
	src/gui/dialogs/midiIO/midiOutputBase.cpp
	src/gui/dialogs/midiIO/midiOutputSampleCh.cpp
	src/gui/dialogs/midiIO/midiOutputMidiCh.cpp
	src/gui/dialogs/midiIO/midiInputBase.cpp
	src/gui/dialogs/midiIO/midiInputChannel.cpp
	src/gui/dialogs/midiIO/midiInputMaster.cpp
	src/gui/elems/midiIO/midiLearner.cpp
	src/gui/elems/midiIO/midiLearnerPack.cpp
	src/gui/elems/browser.cpp
	src/gui/elems/soundMeter.cpp
	src/gui/elems/plugin/pluginBrowser.cpp
	src/gui/elems/plugin/pluginParameter.cpp
	src/gui/elems/plugin/pluginElement.cpp
	src/gui/elems/sampleEditor/waveform.cpp
	src/gui/elems/sampleEditor/waveTools.cpp
	src/gui/elems/sampleEditor/volumeTool.cpp
	src/gui/elems/sampleEditor/boostTool.cpp
	src/gui/elems/sampleEditor/panTool.cpp
	src/gui/elems/sampleEditor/pitchTool.cpp
	src/gui/elems/sampleEditor/rangeTool.cpp
	src/gui/elems/sampleEditor/shiftTool.cpp
	src/gui/elems/actionEditor/baseActionEditor.cpp
	src/gui/elems/actionEditor/baseAction.cpp
	src/gui/elems/actionEditor/envelopeEditor.cpp
	src/gui/elems/actionEditor/velocityEditor.cpp
	src/gui/elems/actionEditor/envelopePoint.cpp
	src/gui/elems/actionEditor/pianoRoll.cpp
	src/gui/elems/actionEditor/pianoItem.cpp
	src/gui/elems/actionEditor/sampleActionEditor.cpp
	src/gui/elems/actionEditor/sampleAction.cpp
	src/gui/elems/actionEditor/gridTool.cpp
	src/gui/elems/actionEditor/splitScroll.cpp
	src/gui/elems/mainWindow/mainIO.cpp
	src/gui/elems/mainWindow/mainMenu.cpp
	src/gui/elems/mainWindow/mainTimer.cpp
	src/gui/elems/mainWindow/mainTransport.cpp
	src/gui/elems/mainWindow/sequencer.cpp
	src/gui/elems/mainWindow/keyboard/channelMode.cpp
	src/gui/elems/mainWindow/keyboard/channelButton.cpp
	src/gui/elems/mainWindow/keyboard/channelStatus.cpp
	src/gui/elems/mainWindow/keyboard/keyboard.cpp
	src/gui/elems/mainWindow/keyboard/column.cpp
	src/gui/elems/mainWindow/keyboard/sampleChannel.cpp
	src/gui/elems/mainWindow/keyboard/midiChannel.cpp
	src/gui/elems/mainWindow/keyboard/channel.cpp
	src/gui/elems/mainWindow/keyboard/sampleChannelButton.cpp
	src/gui/elems/mainWindow/keyboard/midiChannelButton.cpp
	src/gui/elems/config/tabMisc.cpp
	src/gui/elems/config/tabMidi.cpp
	src/gui/elems/config/tabAudio.cpp
	src/gui/elems/config/tabBehaviors.cpp
	src/gui/elems/config/tabPlugins.cpp
	src/gui/elems/basics/scroll.cpp
	src/gui/elems/basics/pack.cpp
	src/gui/elems/basics/group.cpp
	src/gui/elems/basics/scrollPack.cpp
	src/gui/elems/basics/boxtypes.cpp
	src/gui/elems/basics/statusButton.cpp
	src/gui/elems/basics/button.cpp
	src/gui/elems/basics/resizerBar.cpp
	src/gui/elems/basics/input.cpp
	src/gui/elems/basics/liquidScroll.cpp
	src/gui/elems/basics/choice.cpp
	src/gui/elems/basics/dial.cpp
	src/gui/elems/basics/box.cpp
	src/gui/elems/basics/slider.cpp
	src/gui/elems/basics/progress.cpp
	src/gui/elems/basics/check.cpp
	src/gui/elems/basics/split.cpp
	src/utils/log.cpp
	src/utils/time.cpp
	src/utils/math.cpp
	src/utils/gui.cpp
	src/utils/fs.cpp
	src/utils/ver.cpp
	src/utils/string.cpp
	src/deps/rtaudio/RtAudio.cpp
	src/deps/mcl-audio-buffer/src/audioBuffer.cpp)

list(APPEND PREPROCESSOR_DEFS)
list(APPEND INCLUDE_DIRS
	${CMAKE_SOURCE_DIR}
	${CMAKE_SOURCE_DIR}/src)
list(APPEND COMPILER_OPTIONS)
list(APPEND LIBRARIES)
list(APPEND COMPILER_FEATURES cxx_std_17)
list(APPEND TARGET_PROPERTIES)

# ------------------------------------------------------------------------------
# Detect OS
# ------------------------------------------------------------------------------

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
	set(OS_LINUX 1)
elseif(CMAKE_SYSTEM_NAME STREQUAL "Windows")
	set(OS_WINDOWS 1)
elseif(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
	set(OS_MACOS 1)
elseif(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
	set(OS_FREEBSD 1)
else()
	message(FATAL_ERROR "Unsupported platform '${CMAKE_SYSTEM_NAME}', quitting.")
endif()

# ------------------------------------------------------------------------------
# Compiler warnings
# ------------------------------------------------------------------------------

if(DEFINED OS_WINDOWS)
	list(APPEND COMPILER_OPTIONS /W4 /bigobj /external:anglebrackets /external:W0)
else()
	list(APPEND COMPILER_OPTIONS -Wall -Wextra -Wpedantic)
endif()

# ------------------------------------------------------------------------------
# Options
# ------------------------------------------------------------------------------

option(WITH_VST2 "Enable VST2 support." OFF)
option(WITH_VST3 "Enable VST3 support." OFF)
option(WITH_TESTS "Include the test suite." OFF)

if(DEFINED OS_LINUX)
	option(WITH_ALSA "Enable ALSA support (Linux only)." ON)
	option(WITH_PULSE "Enable PulseAudio support (Linux only)." ON)
	option(WITH_JACK "Enable JACK support (Linux only)." ON)
endif()

if(WITH_TESTS)
	list(APPEND PREPROCESSOR_DEFS 
		WITH_TESTS
		TEST_RESOURCES_DIR="${CMAKE_SOURCE_DIR}/tests/resources/")
endif()

if(NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
	list(APPEND PREPROCESSOR_DEFS NDEBUG)
endif()

# ------------------------------------------------------------------------------
# Dependencies
# ------------------------------------------------------------------------------

# Threads (system)

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
list(APPEND LIBRARIES Threads::Threads)

# pkg-config/pkgconf, required to find some external dependencies on some
# platforms
find_package(PkgConfig)

# RtMidi

find_package(RtMidi CONFIG)
if (RtMidi_FOUND)
	list(APPEND LIBRARIES RtMidi::rtmidi)
	message("RtMidi library found in " ${RtMidi_DIR})
elseif (PkgConfig_FOUND)
	pkg_check_modules(RtMidi IMPORTED_TARGET rtmidi)
	if (RtMidi_FOUND)
		list(APPEND LIBRARIES PkgConfig::RtMidi)
		message("RtMidi library found")
	endif()
endif()

if (NOT RtMidi_FOUND)
	# Fallback to find_library mode (in case rtmidi is too old). 
	find_library(LIBRARY_RTMIDI NAMES rtmidi)
	list(APPEND LIBRARIES ${LIBRARY_RTMIDI})

	if (NOT LIBRARY_RTMIDI)
		message(FATAL_ERROR "Can't find RtMidi, aborting.")
	endif()

	# RtMidi header path may vary across OSes, so a fix is needed.
	# TODO - Find a way to avoid this additional step

	find_path(LIBRARY_RTMIDI_INCLUDE_DIR RtMidi.h PATH_SUFFIXES rtmidi)
	list(APPEND INCLUDE_DIRS ${LIBRARY_RTMIDI_INCLUDE_DIR})
	message("RtMidi library found in " ${RtMidi_DIR})
endif()

# FLTK 

set(FLTK_SKIP_FLUID TRUE)  # Don't search for FLTK's fluid
set(FLTK_SKIP_OPENGL TRUE) # Don't search for FLTK's OpenGL
find_package(FLTK REQUIRED NO_MODULE)
list(APPEND LIBRARIES fltk)
list(APPEND INCLUDE_DIRS ${FLTK_INCLUDE_DIRS})
message("FLTK library found in " ${FLTK_DIR})

# Libsndfile

find_package(SndFile CONFIG)
if (SndFile_FOUND)
	list(APPEND LIBRARIES SndFile::sndfile)
	message("Libsndfile library found in " ${SndFile_DIR})
elseif(PkgConfig_FOUND)
	pkg_check_modules(SndFile IMPORTED_TARGET sndfile)
	if (SndFile_FOUND)
		list(APPEND LIBRARIES PkgConfig::SndFile)
		message("Libsndfile library found")
	endif()	
endif()

if (NOT SndFile_FOUND)
	# Fallback to find_library mode (in case libsndfile is too old). 
	find_library(LIBRARY_SNDFILE NAMES sndfile libsndfile libsndfile-1)
	
	if (NOT LIBRARY_SNDFILE)
		message(FATAL_ERROR "Can't find libsndfile, aborting.")
	endif()

	list(APPEND LIBRARIES ${LIBRARY_SNDFILE})
	message("Libsndfile library found in " ${LIBRARY_SNDFILE})

	# Find optional dependencies.

	find_library(LIBRARY_FLAC NAMES flac FLAC)
	find_library(LIBRARY_OGG NAMES ogg)
	find_library(LIBRARY_OPUS NAMES opus libopus)
	find_library(LIBRARY_VORBIS NAMES vorbis)
	find_library(LIBRARY_VORBISENC NAMES vorbisenc)

	if(LIBRARY_FLAC)
		list(APPEND LIBRARIES ${LIBRARY_FLAC})
	endif()
	if(LIBRARY_OGG)
		list(APPEND LIBRARIES ${LIBRARY_OGG})
	endif()
	if(LIBRARY_OPUS)
		list(APPEND LIBRARIES ${LIBRARY_OPUS})
	endif()
	if(LIBRARY_VORBIS)
		list(APPEND LIBRARIES ${LIBRARY_VORBIS})
	endif()
	if(LIBRARY_VORBISENC)
		list(APPEND LIBRARIES ${LIBRARY_VORBISENC})
	endif()	
endif()

# Libsamplerate

find_package(SampleRate CONFIG)
if (SampleRate_FOUND)
	list(APPEND LIBRARIES SampleRate::samplerate)

## giada 0.20.0+ds1

=== debian/changelog ===
giada (0.20.0+ds1-1) unstable; urgency=medium

  * New upstream version 0.20.0+ds1
    - Refresh patches
  * Update dates in d/copyright
    - Regenerate d/copyright_hints
  * Bump d/watch version to 4

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 02 Feb 2022 19:08:36 +0100

=== debian/watch ===
version=4
opts=repacksuffix=+ds1,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/giada-$1\.tar\.gz/,uversionmangle=s/-rc/~rc/,dversionmangle=s/\+ds.*// \
  https://github.com/monocasual/giada/tags .*/v?(\d\S*)\.tar\.gz

## giada 0.20.1+ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -114,6 +114,7 @@
 	src/gui/dialogs/sampleEditor.cpp
 	src/gui/dialogs/pluginWindowGUI.cpp
 	src/gui/dialogs/pluginChooser.cpp
+	src/gui/dialogs/missingAssets.cpp
 	src/gui/dialogs/actionEditor/baseActionEditor.cpp
 	src/gui/dialogs/actionEditor/sampleActionEditor.cpp
 	src/gui/dialogs/actionEditor/midiActionEditor.cpp
@@ -129,7 +130,7 @@
 	src/gui/dialogs/midiIO/midiInputMaster.cpp
 	src/gui/elems/midiIO/midiLearner.cpp
 	src/gui/elems/midiIO/midiLearnerPack.cpp
-	src/gui/elems/browser.cpp
+    src/gui/elems/fileBrowser.cpp
 	src/gui/elems/soundMeter.cpp
 	src/gui/elems/plugin/pluginBrowser.cpp
 	src/gui/elems/plugin/pluginParameter.cpp
@@ -168,6 +169,7 @@
 	src/gui/elems/mainWindow/keyboard/channel.cpp
 	src/gui/elems/mainWindow/keyboard/sampleChannelButton.cpp
 	src/gui/elems/mainWindow/keyboard/midiChannelButton.cpp
+	src/gui/elems/mainWindow/keyboard/midiActivity.cpp
 	src/gui/elems/config/tabMisc.cpp
 	src/gui/elems/config/tabMidi.cpp
 	src/gui/elems/config/tabAudio.cpp
@@ -190,6 +192,8 @@
 	src/gui/elems/basics/progress.cpp
 	src/gui/elems/basics/check.cpp
 	src/gui/elems/basics/split.cpp
+	src/gui/elems/basics/browser.cpp
+	src/gui/elems/basics/flex.cpp
 	src/utils/log.cpp
 	src/utils/time.cpp
 	src/utils/math.cpp
@@ -363,8 +367,3 @@
 	endif()	
 endif()
 
-# Libsamplerate
-
-find_package(SampleRate CONFIG)
-if (SampleRate_FOUND)
-	list(APPEND LIBRARIES SampleRate::samplerate)

=== debian/changelog ===
giada (0.20.1+ds1-1) unstable; urgency=medium

  * New upstream version 0.20.1+ds1
    * Refresh patches
  * Add patch that fixes missing include
  * Update geompp library

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 03 Mar 2022 15:40:12 +0100

=== debian/rules ===
--- 
+++ 
@@ -81,4 +81,3 @@
 		> debian/copyright_newhints
 	cmp debian/copyright_hints debian/copyright_newhints \
 		&& rm debian/copyright_newhints
-

## giada 0.22.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -33,6 +33,7 @@
 
 list(APPEND SOURCES
 	src/main.cpp
+	src/mapper.cpp
 	src/core/engine.cpp
 	src/core/worker.cpp
 	src/core/eventDispatcher.cpp
@@ -77,6 +78,7 @@
 	src/core/channels/midiSender.cpp
 	src/core/channels/midiReceiver.cpp
 	src/core/channels/channel.cpp
+	src/core/channels/channelShared.cpp
 	src/core/channels/channelManager.cpp
 	src/core/model/sequencer.cpp
 	src/core/model/mixer.cpp
@@ -99,6 +101,7 @@
 	src/gui/dialogs/window.cpp
 	src/gui/dispatcher.cpp
 	src/gui/updater.cpp
+	src/gui/langMapper.cpp
 	src/gui/drawing.cpp
 	src/gui/dialogs/progress.cpp
 	src/gui/dialogs/keyGrabber.cpp
@@ -132,13 +135,13 @@
 	src/gui/elems/midiIO/midiLearnerPack.cpp
     src/gui/elems/fileBrowser.cpp
 	src/gui/elems/soundMeter.cpp
+	src/gui/elems/keyBinder.cpp
 	src/gui/elems/plugin/pluginBrowser.cpp
 	src/gui/elems/plugin/pluginParameter.cpp
 	src/gui/elems/plugin/pluginElement.cpp
 	src/gui/elems/sampleEditor/waveform.cpp
 	src/gui/elems/sampleEditor/waveTools.cpp
 	src/gui/elems/sampleEditor/volumeTool.cpp
-	src/gui/elems/sampleEditor/boostTool.cpp
 	src/gui/elems/sampleEditor/panTool.cpp
 	src/gui/elems/sampleEditor/pitchTool.cpp
 	src/gui/elems/sampleEditor/rangeTool.cpp
@@ -175,6 +178,8 @@
 	src/gui/elems/config/tabAudio.cpp
 	src/gui/elems/config/tabBehaviors.cpp
 	src/gui/elems/config/tabPlugins.cpp
+	src/gui/elems/config/tabBindings.cpp
+	src/gui/elems/config/stringMenu.cpp
 	src/gui/elems/basics/scroll.cpp
 	src/gui/elems/basics/pack.cpp
 	src/gui/elems/basics/group.cpp
@@ -194,6 +199,7 @@
 	src/gui/elems/basics/split.cpp
 	src/gui/elems/basics/browser.cpp
 	src/gui/elems/basics/flex.cpp
+	src/gui/elems/basics/tabs.cpp
 	src/utils/log.cpp
 	src/utils/time.cpp
 	src/utils/math.cpp
@@ -300,13 +306,14 @@
 		message(FATAL_ERROR "Can't find RtMidi, aborting.")
 	endif()
 
-	# RtMidi header path may vary across OSes, so a fix is needed.
-	# TODO - Find a way to avoid this additional step
-
-	find_path(LIBRARY_RTMIDI_INCLUDE_DIR RtMidi.h PATH_SUFFIXES rtmidi)
-	list(APPEND INCLUDE_DIRS ${LIBRARY_RTMIDI_INCLUDE_DIR})
 	message("RtMidi library found in " ${RtMidi_DIR})
 endif()
+
+# RtMidi header path may vary across OSes, so a fix is needed.
+# TODO - Find a way to avoid this additional step
+
+find_path(LIBRARY_RTMIDI_INCLUDE_DIR RtMidi.h PATH_SUFFIXES rtmidi)
+list(APPEND INCLUDE_DIRS ${LIBRARY_RTMIDI_INCLUDE_DIR})
 
 # FLTK 
 
@@ -359,11 +366,3 @@
 	if(LIBRARY_OPUS)
 		list(APPEND LIBRARIES ${LIBRARY_OPUS})
 	endif()
-	if(LIBRARY_VORBIS)
-		list(APPEND LIBRARIES ${LIBRARY_VORBIS})
-	endif()
-	if(LIBRARY_VORBISENC)
-		list(APPEND LIBRARIES ${LIBRARY_VORBISENC})
-	endif()	
-endif()
-

=== debian/changelog ===
giada (0.22.0-4build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 05:45:35 +0000

giada (0.22.0-4build1) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 06:36:37 +0000

giada (0.22.0-4) unstable; urgency=medium

  [ Jeremy Bícha ]
  * Build-Depend on libxcursor-dev & drop unused libwebkit2gtk-4.0-dev
    (Closes: #1061411)

  [ IOhannes m zmölnig ]
  * Update copyright information
    + Bump copyright dates
    + Modernize 'licensecheck' target
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 02 Feb 2024 11:43:11 +0100

giada (0.22.0-3) unstable; urgency=medium

  * Add patch to fix FTBFS with gcc-13 (Closes: #1037676)
  * Relax B-D to juce-modules-source-data

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 27 Jul 2023 12:37:36 +0200

giada (0.22.0-2) unstable; urgency=medium

  * B-D on 'fluid'
  * Link against libz
  * Simplify pkg-config handling
  * Bump standards version to 4.6.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 11 Jan 2023 22:47:49 +0100

giada (0.22.0-1) unstable; urgency=medium

  [ Dennis Braun ]
  * New upstream version 0.22.0
  * Refresh patchset, drop desktop file patch applied by upstream
  * Add libfmt-dev to B-Ds
  * Remove double comment entry from desktop file
  * Fix spelling error manifacturer -> manufacturer
  * Add lintian-overrides

  [ IOhannes m zmölnig ]
  * Run 'wrap-and-sort -ast'
  * Patch to fix FTBFS with JUCE-7.0.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sat, 20 Aug 2022 08:54:15 +0200

giada (0.21.0-1) unstable; urgency=medium

  * New upstream version 0.21.0
  * Remove obsolete ds tag
  * Refresh patchset
  * Bump Standards Version to 4.6.1
  * Update mcl-audio-buffer in d/missing-sources
  * The desktop file is now correctly installed by upstream
  * Bring back keywords and translations to the desktop file and add german
    translation
  * Add metainfo file to d/copyright
  * Bump my d/copyright year
  * Add d/upstream/metadata

 -- Dennis Braun <d_braun@kabelmail.de>  Sun, 15 May 2022 18:50:55 +0200

=== debian/control ===
Source: giada
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Jaromír Mikeš <mira.mikes@seznam.cz>,
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
 Dennis Braun <d_braun@kabelmail.de>,
Build-Depends:
 catch2,
 cmake,
 debhelper-compat (= 13),
 fluid,
 fst-dev,
 juce-modules-source-data (>= 6.0.0~),
 libcurl4-gnutls-dev | libcurl-dev,
 libfltk1.3-dev,
 libfmt-dev,
 libjack-dev,
 libjansson-dev,
 libjpeg-dev,
 libjson-c-dev,
 libpng-dev,
 librtaudio-dev,
 librtmidi-dev,
 libsamplerate0-dev,
 libsndfile1-dev,
 libx11-dev,
 libxcursor-dev,
 libxext-dev,
 libxft2-dev,
 libxinerama-dev,
 libxpm-dev,
 libxrandr-dev,
 nlohmann-json3-dev,
 xauth,
 xvfb,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/multimedia-team/giada.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/giada
Homepage: https://www.giadamusic.com

Package: giada
Architecture: any
Built-Using:
 ${juce:BuiltUsing},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 jackd,
Description: Hardcore Loop Machine
 free, minimal, hardcore audio tool for DJs, live performers and electronic
 musicians. Pick up your channel, fill it with samples or MIDI events and start
 the show by using this tiny piece of software as a loop machine, drum machine,
 sequencer, live sampler or yet as a plugin/effect host.
 .
 Giada aims to be a compact and portable virtual device for production use and
 live sets.

=== debian/rules ===
--- 
+++ 
@@ -16,12 +16,13 @@
     BUILD_DATE ?= $(shell date "+$(DATE_FMT)")
 endif
 
-JUCE_VERSION := $(shell dpkg-query --show --showformat='$${source:Version}' juce-modules-source)
+JUCE_VERSION := $(shell dpkg-query --show --showformat='$${source:Version}' juce-modules-source juce-modules-source-data | head -1)
+pkglibs = libjpeg libpng libcurl rtaudio
 
 DEB_CPPFLAGS_MAINT_APPEND += -DBUILD_DATE='"$(BUILD_DATE)"' -DTEST_RESOURCES_DIR='"tests/resources/"'
 DEB_CXXFLAGS_MAINT_APPEND += -std=c++17 -Wno-error -Wno-error=format-security
-LIBS=$(shell pkg-config --libs libjpeg libpng libcurl rtaudio)
-DEB_CXXFLAGS_MAINT_APPEND += $(shell pkg-config --cflags libjpeg libpng libcurl rtaudio)
+DEB_CXXFLAGS_MAINT_APPEND += $(shell pkg-config --cflags $(pkglibs))
+DEB_LDFLAGS_MAINT_APPEND  += $(shell pkg-config --libs $(pkglibs))
 
 # JUCE (used by giada) uses some c++11 features requiring atomic_store_8 and
 # atomic_load_8, so we need to link with libatomic on
@@ -33,10 +34,8 @@
 noatomicarch = $(shell dpkg-architecture -qDEB_HOST_ARCH | egrep -x "(armel|powerpc|powerpcspe|m68k|mips|mipsel|sh4|riscv64)")
 # link with libatomic on architectures without built-in atomic
 ifeq ($(if $(noatomicarch),atomic), atomic)
-	LIBS += -latomic
+	DEB_LDFLAGS_MAINT_APPEND += -latomic
 endif
-
-DEB_LDFLAGS_MAINT_APPEND += $(LIBS)
 
 %:
 	dh $@
@@ -74,10 +73,13 @@
 
 
 DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
-	\.pc/.*|\.git/.*|debian/.*|.*\.png
-
+        debian/.*|.*\.png
+# licensecheck v1
+.PHONY: licensecheck
 licensecheck:
-	licensecheck -i "^\./($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" --deb-machine -r . \
+	LANG=C.UTF-8 licensecheck \
+		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
+		--check '.*' --recursive --deb-machine --lines 0 * \
 		> debian/copyright_newhints
 	cmp debian/copyright_hints debian/copyright_newhints \
 		&& rm debian/copyright_newhints

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/giada-$1\.tar\.gz/ \
  https://github.com/monocasual/giada/tags .*/v?(\d\S*)\.tar\.gz

## giada 1.2.1

=== CMakeLists.txt ===
# ------------------------------------------------------------------------------
# Preliminary setup
# ------------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.29)

# CMAKE_OSX_DEPLOYMENT_TARGET should be set prior to the first project() or
# enable_language() command invocation because it may influence configuration
# of the toolchain and flags.
# Also, see https://stackoverflow.com/questions/34208360/cmake-seems-to-ignore-cmake-osx-deployment-target

if(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
	set(CMAKE_OSX_DEPLOYMENT_TARGET "10.14" CACHE STRING "Minimum OS X deployment version")
endif()

# ------------------------------------------------------------------------------
# Project
# ------------------------------------------------------------------------------

project(giada LANGUAGES C CXX)

# ------------------------------------------------------------------------------
# Lists definition
#
# SOURCES - contains the source files
# PREPROCESSOR_DEFS - preprocessor definitions
# INCLUDE_DIRS - include directories (e.g. -I)
# COMPILER_OPTIONS - additional flags for the compiler
# LIBRARIES - external dependencies to link
# COMPILER_FEATURES - e.g. C++17
# TARGET_PROPERTIES - additional properties for the target 'giada'.
# ------------------------------------------------------------------------------

list(APPEND SOURCES
	src/main.cpp
	src/mapper.cpp
	src/mapper.h
	src/core/engine.cpp
	src/core/engine.h
	src/core/rendering/renderer.cpp
	src/core/rendering/renderer.h
	src/core/rendering/reactor.cpp
	src/core/rendering/reactor.h
	src/core/rendering/sampleReactions.cpp
	src/core/rendering/sampleReactions.h
	src/core/rendering/sampleRendering.cpp
	src/core/rendering/sampleRendering.h
	src/core/rendering/sampleAdvance.cpp
	src/core/rendering/sampleAdvance.h
	src/core/rendering/midiReactions.cpp
	src/core/rendering/midiReactions.h
	src/core/rendering/midiAdvance.cpp
	src/core/rendering/midiAdvance.h
	src/core/rendering/midiOutput.cpp
	src/core/rendering/midiOutput.h
	src/core/rendering/pluginRendering.cpp
	src/core/rendering/pluginRendering.h
	src/core/api/mainApi.cpp
	src/core/api/mainApi.h
	src/core/api/channelsApi.cpp
	src/core/api/channelsApi.h
	src/core/api/sampleEditorApi.cpp
	src/core/api/sampleEditorApi.h
	src/core/api/actionEditorApi.cpp
	src/core/api/actionEditorApi.h
	src/core/api/pluginsApi.cpp
	src/core/api/pluginsApi.h
	src/core/api/storageApi.cpp
	src/core/api/storageApi.h
	src/core/api/IOApi.cpp
	src/core/api/IOApi.h
	src/core/api/configApi.cpp
	src/core/api/configApi.h
	src/core/worker.cpp
	src/core/worker.h
	src/core/eventDispatcher.cpp
	src/core/eventDispatcher.h
	src/core/midiDispatcher.cpp
	src/core/midiDispatcher.h
	src/core/midiMapper.cpp
	src/core/midiMapper.h
	src/core/midiEvent.cpp
	src/core/midiEvent.h
	src/core/quantizer.cpp
	src/core/quantizer.h
	src/core/confFactory.cpp
	src/core/confFactory.h
	src/core/patchFactory.cpp
	src/core/patchFactory.h
	src/core/kernelAudio.cpp
	src/core/kernelAudio.h
	src/core/jackTransport.cpp
	src/core/jackTransport.h
	src/core/sequencer.cpp
	src/core/sequencer.h
	src/core/metronome.cpp
	src/core/metronome.h
	src/core/init.cpp
	src/core/init.h
	src/core/wave.cpp
	src/core/wave.h
	src/core/waveFx.cpp
	src/core/waveFx.h
	src/core/kernelMidi.cpp
	src/core/kernelMidi.h
	src/core/patch.cpp
	src/core/patch.h
	src/core/actions/actionFactory.cpp
	src/core/actions/actionFactory.h
	src/core/actions/actionRecorder.cpp
	src/core/actions/actionRecorder.h
	src/core/mixer.cpp
	src/core/mixer.h
	src/core/jackSynchronizer.cpp
	src/core/jackSynchronizer.h
	src/core/midiSynchronizer.cpp
	src/core/midiSynchronizer.h
	src/core/waveFactory.cpp
	src/core/waveFactory.h
	src/core/recorder.cpp
	src/core/recorder.h
	src/core/midiLearnParam.cpp
	src/core/midiLearnParam.h
	src/core/resampler.cpp
	src/core/resampler.h
	src/core/plugins/pluginHost.cpp
	src/core/plugins/pluginHost.h
	src/core/plugins/pluginManager.cpp
	src/core/plugins/pluginManager.h
	src/core/plugins/plugin.cpp
	src/core/plugins/plugin.h
	src/core/plugins/pluginState.cpp
	src/core/plugins/pluginState.h
	src/core/plugins/pluginFactory.cpp
	src/core/plugins/pluginFactory.h
	src/core/channels/channelManager.cpp
	src/core/channels/channelManager.h
	src/core/channels/midiLightning.cpp
	src/core/channels/midiLightning.h
	src/core/channels/midiInput.cpp
	src/core/channels/midiInput.h
	src/core/channels/channel.cpp
	src/core/channels/channel.h
	src/core/channels/sampleChannel.cpp
	src/core/channels/sampleChannel.h
	src/core/channels/midiChannel.cpp
	src/core/channels/midiChannel.h
	src/core/channels/channelShared.cpp
	src/core/channels/channelShared.h
	src/core/channels/channelFactory.cpp
	src/core/channels/channelFactory.h
	src/core/model/document.cpp
	src/core/model/document.h
	src/core/model/loadState.cpp
	src/core/model/loadState.h
	src/core/model/sharedLock.cpp
	src/core/model/sharedLock.h
	src/core/model/shared.cpp
	src/core/model/shared.h
	src/core/model/sequencer.cpp
	src/core/model/sequencer.h
	src/core/model/mixer.cpp
	src/core/model/mixer.h
	src/core/model/model.cpp
	src/core/model/model.h
	src/core/model/channels.cpp
	src/core/model/channels.h
	src/core/model/actions.cpp
	src/core/model/actions.h
	src/core/model/tracks.cpp
	src/core/model/tracks.h
	src/core/model/track.cpp
	src/core/model/track.h
	src/core/idManager.cpp
	src/core/idManager.h
	src/glue/main.cpp
	src/glue/main.h
	src/glue/io.cpp
	src/glue/io.h
	src/glue/storage.cpp
	src/glue/storage.h
	src/glue/channel.cpp
	src/glue/channel.h
	src/glue/plugin.cpp
	src/glue/plugin.h
	src/glue/sampleEditor.cpp
	src/glue/sampleEditor.h
	src/glue/actionEditor.cpp
	src/glue/actionEditor.h
	src/glue/config.cpp
	src/glue/config.h
	src/glue/layout.cpp
	src/glue/layout.h
	src/gui/ui.cpp
	src/gui/ui.h
	src/gui/model.cpp
	src/gui/model.h
	src/gui/dialogs/window.cpp
	src/gui/dialogs/window.h
	src/gui/dispatcher.cpp
	src/gui/dispatcher.h
	src/gui/updater.cpp
	src/gui/updater.h
	src/gui/langMapper.cpp
	src/gui/langMapper.h
	src/gui/drawing.cpp
	src/gui/drawing.h
	src/gui/dialogs/progress.cpp
	src/gui/dialogs/progress.h
	src/gui/dialogs/keyGrabber.cpp
	src/gui/dialogs/keyGrabber.h
	src/gui/dialogs/about.cpp
	src/gui/dialogs/about.h
	src/gui/dialogs/mainWindow.cpp
	src/gui/dialogs/mainWindow.h
	src/gui/dialogs/beatsInput.cpp
	src/gui/dialogs/beatsInput.h
	src/gui/dialogs/warnings.cpp
	src/gui/dialogs/warnings.h
	src/gui/dialogs/bpmInput.cpp
	src/gui/dialogs/bpmInput.h
	src/gui/dialogs/channelNameInput.cpp
	src/gui/dialogs/channelNameInput.h
	src/gui/dialogs/channelRouting.cpp
	src/gui/dialogs/channelRouting.h
	src/gui/dialogs/config.cpp
	src/gui/dialogs/config.h
	src/gui/dialogs/pluginList.cpp
	src/gui/dialogs/pluginList.h
	src/gui/dialogs/pluginWindow.cpp
	src/gui/dialogs/pluginWindow.h
	src/gui/dialogs/sampleEditor.cpp
	src/gui/dialogs/sampleEditor.h
	src/gui/dialogs/pluginWindowGUI.cpp
	src/gui/dialogs/pluginWindowGUI.h
	src/gui/dialogs/pluginChooser.cpp
	src/gui/dialogs/pluginChooser.h
	src/gui/dialogs/missingAssets.cpp
	src/gui/dialogs/missingAssets.h
	src/gui/dialogs/actionEditor/baseActionEditor.cpp
	src/gui/dialogs/actionEditor/baseActionEditor.h
	src/gui/dialogs/actionEditor/sampleActionEditor.cpp
	src/gui/dialogs/actionEditor/sampleActionEditor.h
	src/gui/dialogs/actionEditor/midiActionEditor.cpp
	src/gui/dialogs/actionEditor/midiActionEditor.h
	src/gui/dialogs/browser/browserBase.cpp
	src/gui/dialogs/browser/browserBase.h
	src/gui/dialogs/browser/browserDir.cpp
	src/gui/dialogs/browser/browserDir.h
	src/gui/dialogs/browser/browserLoad.cpp
	src/gui/dialogs/browser/browserLoad.h
	src/gui/dialogs/browser/browserSave.cpp
	src/gui/dialogs/browser/browserSave.h
	src/gui/dialogs/midiIO/midiOutputBase.cpp
	src/gui/dialogs/midiIO/midiOutputBase.h
	src/gui/dialogs/midiIO/midiOutputSampleCh.cpp
	src/gui/dialogs/midiIO/midiOutputSampleCh.h
	src/gui/dialogs/midiIO/midiOutputMidiCh.cpp
	src/gui/dialogs/midiIO/midiOutputMidiCh.h
	src/gui/dialogs/midiIO/midiInputBase.cpp
	src/gui/dialogs/midiIO/midiInputBase.h
	src/gui/dialogs/midiIO/midiInputChannel.cpp
	src/gui/dialogs/midiIO/midiInputChannel.h
	src/gui/dialogs/midiIO/midiInputMaster.cpp
	src/gui/dialogs/midiIO/midiInputMaster.h
	src/gui/elems/midiIO/midiLearner.cpp
	src/gui/elems/midiIO/midiLearner.h
	src/gui/elems/midiIO/midiLearnerPack.cpp
	src/gui/elems/midiIO/midiLearnerPack.h
	src/gui/elems/fileBrowser.cpp
	src/gui/elems/fileBrowser.h
	src/gui/elems/soundMeter.cpp
	src/gui/elems/soundMeter.h
	src/gui/elems/keyBinder.cpp
	src/gui/elems/keyBinder.h
	src/gui/elems/plugin/pluginBrowser.cpp
	src/gui/elems/plugin/pluginBrowser.h
	src/gui/elems/plugin/pluginParameter.cpp
	src/gui/elems/plugin/pluginParameter.h
	src/gui/elems/plugin/pluginElement.cpp
	src/gui/elems/plugin/pluginElement.h
	src/gui/elems/sampleEditor/waveform.cpp
	src/gui/elems/sampleEditor/waveform.h
	src/gui/elems/sampleEditor/waveTools.cpp
	src/gui/elems/sampleEditor/waveTools.h
	src/gui/elems/volumeTool.cpp
	src/gui/elems/volumeTool.h
	src/gui/elems/panTool.cpp
	src/gui/elems/panTool.h
	src/gui/elems/midiActivity.cpp
	src/gui/elems/midiActivity.h
	src/gui/elems/sampleEditor/pitchTool.cpp
	src/gui/elems/sampleEditor/pitchTool.h
	src/gui/elems/sampleEditor/rangeTool.cpp
	src/gui/elems/sampleEditor/rangeTool.h
	src/gui/elems/sampleEditor/shiftTool.cpp
	src/gui/elems/sampleEditor/shiftTool.h
	src/gui/elems/actionEditor/baseActionEditor.cpp
	src/gui/elems/actionEditor/baseActionEditor.h
	src/gui/elems/actionEditor/baseAction.cpp
	src/gui/elems/actionEditor/baseAction.h
	src/gui/elems/actionEditor/velocityEditor.cpp
	src/gui/elems/actionEditor/velocityEditor.h
	src/gui/elems/actionEditor/envelopePoint.cpp
	src/gui/elems/actionEditor/envelopePoint.h
	src/gui/elems/actionEditor/pianoRoll.cpp
	src/gui/elems/actionEditor/pianoRoll.h
	src/gui/elems/actionEditor/pianoItem.cpp
	src/gui/elems/actionEditor/pianoItem.h
	src/gui/elems/actionEditor/sampleActionEditor.cpp
	src/gui/elems/actionEditor/sampleActionEditor.h
	src/gui/elems/actionEditor/sampleAction.cpp
	src/gui/elems/actionEditor/sampleAction.h
	src/gui/elems/actionEditor/gridTool.cpp
	src/gui/elems/actionEditor/gridTool.h
	src/gui/elems/actionEditor/splitScroll.cpp
	src/gui/elems/actionEditor/splitScroll.h
	src/gui/elems/actionEditor/legend.cpp
	src/gui/elems/actionEditor/legend.h
	src/gui/elems/actionEditor/pianoRollLegend.cpp
	src/gui/elems/actionEditor/pianoRollLegend.h
	src/gui/elems/mainWindow/mainInput.cpp
	src/gui/elems/mainWindow/mainInput.h
	src/gui/elems/mainWindow/mainOutput.cpp
	src/gui/elems/mainWindow/mainOutput.h
	src/gui/elems/mainWindow/mainMenu.cpp
	src/gui/elems/mainWindow/mainMenu.h
	src/gui/elems/mainWindow/mainTimer.cpp
	src/gui/elems/mainWindow/mainTimer.h
	src/gui/elems/mainWindow/mainTransport.cpp
	src/gui/elems/mainWindow/mainTransport.h
	src/gui/elems/mainWindow/sequencer.cpp
	src/gui/elems/mainWindow/sequencer.h
	src/gui/elems/mainWindow/keyboard/sampleChannelMode.cpp
	src/gui/elems/mainWindow/keyboard/sampleChannelMode.h
	src/gui/elems/mainWindow/keyboard/channelButton.cpp
	src/gui/elems/mainWindow/keyboard/channelButton.h
	src/gui/elems/mainWindow/keyboard/channelProgress.cpp
	src/gui/elems/mainWindow/keyboard/channelProgress.h
	src/gui/elems/mainWindow/keyboard/keyboard.cpp
	src/gui/elems/mainWindow/keyboard/keyboard.h
	src/gui/elems/mainWindow/keyboard/track.cpp
	src/gui/elems/mainWindow/keyboard/track.h
	src/gui/elems/mainWindow/keyboard/sampleChannel.cpp
	src/gui/elems/mainWindow/keyboard/sampleChannel.h
	src/gui/elems/mainWindow/keyboard/midiChannel.cpp
	src/gui/elems/mainWindow/keyboard/midiChannel.h
	src/gui/elems/mainWindow/keyboard/groupChannel.cpp
	src/gui/elems/mainWindow/keyboard/groupChannel.h
	src/gui/elems/mainWindow/keyboard/channel.cpp
	src/gui/elems/mainWindow/keyboard/channel.h
	src/gui/elems/mainWindow/keyboard/sampleChannelButton.cpp
	src/gui/elems/mainWindow/keyboard/sampleChannelButton.h
	src/gui/elems/mainWindow/keyboard/midiChannelButton.cpp

=== debian/changelog ===
giada (1.2.1-1) unstable; urgency=medium

  * New upstream version 1.2.1
    + Drop obsolete patches
    + Refresh patches
  * Refresh vendored geompp library
  * Update missing sources for mcl-audio-buffer & mcl-atomic-swapper
  * Revised RtAudio dependency
    + Update RtAudio patch (Closes: #1073997)
  * Revised FLTK dependency
    + Bump B-D to fltk1.4-dev (Closes: #1100527)
    + Patch to build against Debian's FLTK
    + Hack to get linking against fltk to work
  * Revised JUCE dependency
    + B-D on juce-modules-source
    + Add patch to use Debian's JUCE
    + Stop copying JUCE sources around
    + Explicitly link against implicit dependencies of JUCE
  * Revised VST support
    + Enable VST3 support
    + Set VST2_SDK_PATH
    + Drop workarounds for FST bugs
  * Revised more dependency handling
    + Fix systemJPG/PNG patch
    + Add patch to use Debian's libconcurrentqueue
    + Patch to allow adding additional libraries to link against
    + Manually add flags for libcairo
    + Evaluate pkg-config only once
  * Fix typo in cleanup
  * Drop uneeded lintian-override
  * Update copyright information
    + Bump copyright dates
    + Re-generate d/copyright_hints
  * Apply 'wrap-and-sort -ast'
  * Update git repository layout to follow DEP-14
  * Bump standards version to 4.7.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 25 Aug 2025 22:08:10 +0200

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,21 @@
 Source: giada
 Section: sound
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Jaromír Mikeš <mira.mikes@seznam.cz>,
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
  Dennis Braun <d_braun@kabelmail.de>,
 Build-Depends:
+ debhelper-compat (= 13),
  catch2,
  cmake,
- debhelper-compat (= 13),
  fluid,
  fst-dev,
- juce-modules-source-data (>= 6.0.0~),
+ juce-modules-source (>= 8.0.8~),
+ libconcurrentqueue-dev,
  libcurl4-gnutls-dev | libcurl-dev,
- libfltk1.3-dev,
+ libfltk1.4-dev,
  libfmt-dev,
  libjack-dev,
  libjansson-dev,
@@ -26,6 +26,7 @@
  librtmidi-dev,
  libsamplerate0-dev,
  libsndfile1-dev,
+ libvst3sdk-dev,
  libx11-dev,
  libxcursor-dev,
  libxext-dev,
@@ -36,7 +37,7 @@
  nlohmann-json3-dev,
  xauth,
  xvfb,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/multimedia-team/giada.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/giada

=== debian/rules ===
--- 
+++ 
@@ -5,9 +5,6 @@
 export DEB_CPPFLAGS_MAINT_APPEND =
 export DEB_CXXFLAGS_MAINT_APPEND =
 export DEB_LDFLAGS_MAINT_APPEND =
-
-# workaround for an FST bug
-DEB_CPPFLAGS_MAINT_APPEND += -D_fstEffect=AEffect
 
 DATE_FMT = %Y-%m-%d
 ifdef SOURCE_DATE_EPOCH
@@ -17,12 +14,17 @@
 endif
 
 JUCE_VERSION := $(shell dpkg-query --show --showformat='$${source:Version}' juce-modules-source juce-modules-source-data | head -1)
-pkglibs = libjpeg libpng libcurl rtaudio
+pkglibs := libjpeg libpng flac vorbis vorbisfile vorbisenc ogg zlib libcurl rtaudio cairo
+
+PKG_CONFIG ?= pkg-config
+pkglibs_cflags := $(shell $(PKG_CONFIG) --cflags $(pkglibs))
+pkglibs_libs := $(shell $(PKG_CONFIG) --libs $(pkglibs))
+
 
 DEB_CPPFLAGS_MAINT_APPEND += -DBUILD_DATE='"$(BUILD_DATE)"' -DTEST_RESOURCES_DIR='"tests/resources/"'
 DEB_CXXFLAGS_MAINT_APPEND += -std=c++17 -Wno-error -Wno-error=format-security
-DEB_CXXFLAGS_MAINT_APPEND += $(shell pkg-config --cflags $(pkglibs))
-DEB_LDFLAGS_MAINT_APPEND  += $(shell pkg-config --libs $(pkglibs))
+DEB_CXXFLAGS_MAINT_APPEND += $(pkglibs_cflags)
+DEB_LDFLAGS_MAINT_APPEND  += $(pkglibs_libs)
 
 # JUCE (used by giada) uses some c++11 features requiring atomic_store_8 and
 # atomic_load_8, so we need to link with libatomic on
@@ -45,24 +47,21 @@
 		mkdir -p src/deps/$$d/src/; \
 		cp debian/missing-sources/$$d/* src/deps/$$d/src/; \
 	done
-	cp -ra /usr/share/juce src/deps/
-	# patch around some bugs in FST
-	sed -e 's|\(.*t_fstTimeInfo.smpteFrameRate.*\)|};\ntypedef enum {\1|' -e 's|\(.*SmpteFilm35mm.*\)|\1 } VstSmpteFrameRate;\nenum {dummy_enum|' /usr/include/pluginterfaces/fst/fst.h > src/deps/juce/modules/juce_audio_processors/format_types/fst.h
-	sed -e 's|<pluginterfaces/fst/fst.h>|"fst.h"|' -i src/deps/juce/modules/juce_audio_processors/format_types/juce_VSTPluginFormat.cpp
 override_dh_auto_configure:
 	dh_auto_configure -- \
-		-DWITH_VST2=ON \
+		-DWITH_VST2=ON -DVST2_SDK_PATH=/usr/include \
+		-DWITH_VST3=ON \
+		-DEXTRA_LIBRARIES="$(DEB_LDFLAGS_MAINT_APPEND)" \
 		$(empty)
 
 override_dh_auto_test:
 	HOME=/tmp xvfb-run -a dh_auto_test -a || (grep . test-suite.log giada_test.log; false)
 
 execute_after_dh_clean:
-	test -e src/deps/rtaudio-mode/Makefile && make -C src/deps/rtaudio-mod/ distclean || true
+	test -e src/deps/rtaudio-mod/Makefile && make -C src/deps/rtaudio-mod/ distclean || true
 	for d in $(notdir $(patsubst %/,%,$(wildcard debian/missing-sources/mcl-*/))); do \
 		rm -rf src/deps/$$d; \
 	done
-	rm -rf src/deps/juce/
 
 override_dh_installchangelogs:
 	dh_installchangelogs ChangeLog

## giada 1.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -33,8 +33,10 @@
 
 list(APPEND SOURCES
 	src/main.cpp
+	src/const.h
 	src/mapper.cpp
 	src/mapper.h
+	src/version.h
 	src/core/engine.cpp
 	src/core/engine.h
 	src/core/rendering/renderer.cpp
@@ -73,6 +75,8 @@
 	src/core/api/configApi.h
 	src/core/worker.cpp
 	src/core/worker.h
+	src/core/pan.cpp
+	src/core/pan.h
 	src/core/eventDispatcher.cpp
 	src/core/eventDispatcher.h
 	src/core/midiDispatcher.cpp
@@ -103,7 +107,6 @@
 	src/core/waveFx.h
 	src/core/kernelMidi.cpp
 	src/core/kernelMidi.h
-	src/core/patch.cpp
 	src/core/patch.h
 	src/core/actions/actionFactory.cpp
 	src/core/actions/actionFactory.h
@@ -191,6 +194,7 @@
 	src/glue/config.h
 	src/glue/layout.cpp
 	src/glue/layout.h
+	src/gui/const.h
 	src/gui/ui.cpp
 	src/gui/ui.h
 	src/gui/model.cpp
@@ -351,4 +355,3 @@
 	src/gui/elems/mainWindow/keyboard/channel.h
 	src/gui/elems/mainWindow/keyboard/sampleChannelButton.cpp
 	src/gui/elems/mainWindow/keyboard/sampleChannelButton.h
-	src/gui/elems/mainWindow/keyboard/midiChannelButton.cpp

=== debian/changelog ===
giada (1.3.0-1) unstable; urgency=medium

  * New upstream version 1.3.0
    + Refresh patches
  * Update mcl-audio-buffer
  * Include verbatim copy of 'geompp' (rather than patching it in)
  * Use dh_builtusing for Built-Using
  * Update d/watch
  * Update copyright information
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sat, 04 Oct 2025 18:29:08 +0200

=== debian/rules ===
--- 
+++ 
@@ -43,7 +43,7 @@
 	dh $@
 
 execute_before_dh_auto_configure:
-	for d in $(notdir $(patsubst %/,%,$(wildcard debian/missing-sources/mcl-*/))); do \
+	for d in $(notdir $(patsubst %/,%,$(wildcard debian/missing-sources/*/))); do \
 		mkdir -p src/deps/$$d/src/; \
 		cp debian/missing-sources/$$d/* src/deps/$$d/src/; \
 	done
@@ -59,16 +59,12 @@
 
 execute_after_dh_clean:
 	test -e src/deps/rtaudio-mod/Makefile && make -C src/deps/rtaudio-mod/ distclean || true
-	for d in $(notdir $(patsubst %/,%,$(wildcard debian/missing-sources/mcl-*/))); do \
+	for d in $(notdir $(patsubst %/,%,$(wildcard debian/missing-sources/*/))); do \
 		rm -rf src/deps/$$d; \
 	done
 
 override_dh_installchangelogs:
 	dh_installchangelogs ChangeLog
-
-override_dh_gencontrol:
-	dh_gencontrol -- \
-                -Vjuce:BuiltUsing="juce ( = $(JUCE_VERSION) )"
 
 
 DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \

=== debian/watch ===
Version: 5

Template: Github
Owner: monocasual
Project: giada

## giada 1.3.1

=== debian/changelog ===
giada (1.3.1-1) unstable; urgency=medium

  * New upstream version 1.3.1

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 07 Nov 2025 14:22:03 +0100

=== debian/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
  Dennis Braun <d_braun@kabelmail.de>,
 Build-Depends:
  debhelper-compat (= 13),
+ dh-sequence-builtusing,
  catch2,
  cmake,
  fluid,
@@ -46,7 +47,7 @@
 Package: giada
 Architecture: any
 Built-Using:
- ${juce:BuiltUsing},
+ ${dh-builtusing:juce-modules-source},
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
